package kernel.service;

import kernel.ps.Process;
import kernel.ps.ProcessManager;
import kernel.binstore.BinStore;

using tink.CoreApi;

class Service {
	public final binName:String;
	public final name:String;
	public final args:Array<String>;
	public var pid:PID;
	public var ps:Process;

	@:allow(kernel.service.ServiceManager)
	private function new(binName:String, name:String, ?args:Array<String>) {
		this.binName = binName;
		this.name = name;
		this.args = args ?? [];
	}

	public function start() {
		var bin = BinStore.getBinByAlias(this.binName);

		if (bin == null) {
			throw new Error('Bin ${this.binName} not found');
		}

		this.ps = Type.createInstance(bin.c, this.args);

		this.pid = ProcessManager.run(this.ps, {});
	}

	public function stop() {
		ProcessManager.kill(this.pid);
	}
}
